--- old/usr/src/uts/common/vm/seg_dev.c	2015-11-24 09:35:06.144982214 -0500
+++ new/usr/src/uts/common/vm/seg_dev.c	2015-11-24 09:35:06.149086364 -0500
@@ -181,7 +181,6 @@
 static void	segdev_dump(struct seg *);
 static int	segdev_pagelock(struct seg *, caddr_t, size_t,
 		    struct page ***, enum lock_type, enum seg_rw);
-static int	segdev_setpagesize(struct seg *, caddr_t, size_t, uint_t);
 static int	segdev_getmemid(struct seg *, caddr_t, memid_t *);
 
 /*
@@ -208,7 +207,6 @@
 	.advise		= segdev_advise,
 	.dump		= segdev_dump,
 	.pagelock	= segdev_pagelock,
-	.setpagesize	= segdev_setpagesize,
 	.getmemid	= segdev_getmemid,
 };
 
@@ -2474,14 +2472,6 @@
 	return (ENOTSUP);
 }
 
-/*ARGSUSED*/
-static int
-segdev_setpagesize(struct seg *seg, caddr_t addr, size_t len,
-    uint_t szc)
-{
-	return (ENOTSUP);
-}
-
 /*
  * devmap_device: Used by devmap framework to establish mapping
  *                called by devmap_seup(9F) during map setup time.
--- old/usr/src/uts/common/vm/seg_spt.c	2015-11-24 09:35:06.353312867 -0500
+++ new/usr/src/uts/common/vm/seg_spt.c	2015-11-24 09:35:06.357197379 -0500
@@ -139,7 +139,6 @@
 static void segspt_shmdump(struct seg *seg);
 static int segspt_shmpagelock(struct seg *, caddr_t, size_t,
 			struct page ***, enum lock_type, enum seg_rw);
-static int segspt_shmsetpgsz(struct seg *, caddr_t, size_t, uint_t);
 static int segspt_shmgetmemid(struct seg *, caddr_t, memid_t *);
 static lgrp_mem_policy_info_t *segspt_shmgetpolicy(struct seg *, caddr_t);
 
@@ -163,7 +162,6 @@
 	.advise		= segspt_shmadvise,
 	.dump		= segspt_shmdump,
 	.pagelock	= segspt_shmpagelock,
-	.setpagesize	= segspt_shmsetpgsz,
 	.getmemid	= segspt_shmgetmemid,
 	.getpolicy	= segspt_shmgetpolicy,
 };
@@ -3017,13 +3015,6 @@
 	/* no-op for ISM segment */
 }
 
-/*ARGSUSED*/
-static faultcode_t
-segspt_shmsetpgsz(struct seg *seg, caddr_t addr, size_t len, uint_t szc)
-{
-	return (ENOTSUP);
-}
-
 /*
  * get a memory ID for an addr in a given segment
  */
--- old/usr/src/uts/common/vm/vm_seg.c	2015-11-24 09:35:06.535579555 -0500
+++ new/usr/src/uts/common/vm/vm_seg.c	2015-11-24 09:35:06.539655435 -0500
@@ -1977,6 +1977,9 @@
 int
 segop_setpagesize(struct seg *seg, caddr_t addr, size_t len, uint_t szc)
 {
+	if (seg->s_ops->setpagesize == NULL)
+		return (ENOTSUP);
+
 	return (seg->s_ops->setpagesize(seg, addr, len, szc));
 }
 
--- old/usr/src/uts/i86xpv/vm/seg_mf.c	2015-11-24 09:35:06.700521063 -0500
+++ new/usr/src/uts/i86xpv/vm/seg_mf.c	2015-11-24 09:35:06.704456078 -0500
@@ -482,13 +482,6 @@
 	return (ENOTSUP);
 }
 
-/*ARGSUSED*/
-static int
-segmf_setpagesize(struct seg *seg, caddr_t addr, size_t len, uint_t szc)
-{
-	return (ENOTSUP);
-}
-
 static int
 segmf_getmemid(struct seg *seg, caddr_t addr, memid_t *memid)
 {
@@ -762,6 +755,5 @@
 	.advise		= segmf_advise,
 	.dump		= segmf_dump,
 	.pagelock	= segmf_pagelock,
-	.setpagesize	= segmf_setpagesize,
 	.getmemid	= segmf_getmemid,
 };
--- old/usr/src/uts/sparc/v9/vm/seg_nf.c	2015-11-24 09:35:06.828483883 -0500
+++ new/usr/src/uts/sparc/v9/vm/seg_nf.c	2015-11-24 09:35:06.832375034 -0500
@@ -76,8 +76,6 @@
 static void	segnf_dump(struct seg *seg);
 static int	segnf_pagelock(struct seg *seg, caddr_t addr, size_t len,
 		    struct page ***ppp, enum lock_type type, enum seg_rw rw);
-static int	segnf_setpagesize(struct seg *seg, caddr_t addr, size_t len,
-		    uint_t szc);
 
 
 struct seg_ops segnf_ops = {
@@ -104,7 +102,6 @@
 		segnf_nop,
 	.dump		= segnf_dump,
 	.pagelock	= segnf_pagelock,
-	.setpagesize	= segnf_setpagesize,
 };
 
 /*
@@ -464,11 +461,3 @@
 {
 	return (ENOTSUP);
 }
-
-/*ARGSUSED*/
-static int
-segnf_setpagesize(struct seg *seg, caddr_t addr, size_t len,
-    uint_t szc)
-{
-	return (ENOTSUP);
-}
